git rebase --abort: always restore the right commit
[git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 # For repeatability, reset the environment to known value.
7 LANG=C
8 LC_ALL=C
9 PAGER=cat
10 TZ=UTC
11 export LANG LC_ALL PAGER TZ
12 EDITOR=:
13 VISUAL=:
14 unset GIT_EDITOR
15 unset AUTHOR_DATE
16 unset AUTHOR_EMAIL
17 unset AUTHOR_NAME
18 unset COMMIT_AUTHOR_EMAIL
19 unset COMMIT_AUTHOR_NAME
20 unset EMAIL
21 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
22 unset GIT_AUTHOR_DATE
23 GIT_AUTHOR_EMAIL=author@example.com
24 GIT_AUTHOR_NAME='A U Thor'
25 unset GIT_COMMITTER_DATE
26 GIT_COMMITTER_EMAIL=committer@example.com
27 GIT_COMMITTER_NAME='C O Mitter'
28 unset GIT_DIFF_OPTS
29 unset GIT_DIR
30 unset GIT_WORK_TREE
31 unset GIT_EXTERNAL_DIFF
32 unset GIT_INDEX_FILE
33 unset GIT_OBJECT_DIRECTORY
34 unset SHA1_FILE_DIRECTORIES
35 unset SHA1_FILE_DIRECTORY
36 GIT_MERGE_VERBOSITY=5
37 export GIT_MERGE_VERBOSITY
38 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
39 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
40 export EDITOR VISUAL
41
42 # Protect ourselves from common misconfiguration to export
43 # CDPATH into the environment
44 unset CDPATH
45
46 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
47         1|2|true)
48                 echo "* warning: Some tests will not work if GIT_TRACE" \
49                         "is set as to trace on STDERR ! *"
50                 echo "* warning: Please set GIT_TRACE to something" \
51                         "other than 1, 2 or true ! *"
52                 ;;
53 esac
54
55 # Each test should start with something like this, after copyright notices:
56 #
57 # test_description='Description of this test...
58 # This test checks if command xyzzy does the right thing...
59 # '
60 # . ./test-lib.sh
61
62 [ "x$TERM" != "xdumb" ] &&
63         [ -t 1 ] &&
64         tput bold >/dev/null 2>&1 &&
65         tput setaf 1 >/dev/null 2>&1 &&
66         tput sgr0 >/dev/null 2>&1 &&
67         color=t
68
69 while test "$#" -ne 0
70 do
71         case "$1" in
72         -d|--d|--de|--deb|--debu|--debug)
73                 debug=t; shift ;;
74         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
75                 immediate=t; shift ;;
76         -h|--h|--he|--hel|--help)
77                 help=t; shift ;;
78         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
79                 verbose=t; shift ;;
80         -q|--q|--qu|--qui|--quie|--quiet)
81                 quiet=t; shift ;;
82         --no-color)
83             color=; shift ;;
84         --no-python)
85                 # noop now...
86                 shift ;;
87         *)
88                 break ;;
89         esac
90 done
91
92 if test -n "$color"; then
93         say_color () {
94                 case "$1" in
95                         error) tput bold; tput setaf 1;; # bold red
96                         skip)  tput bold; tput setaf 2;; # bold green
97                         pass)  tput setaf 2;;            # green
98                         info)  tput setaf 3;;            # brown
99                         *) test -n "$quiet" && return;;
100                 esac
101                 shift
102                 echo "* $*"
103                 tput sgr0
104         }
105 else
106         say_color() {
107                 test -z "$1" && test -n "$quiet" && return
108                 shift
109                 echo "* $*"
110         }
111 fi
112
113 error () {
114         say_color error "error: $*"
115         trap - exit
116         exit 1
117 }
118
119 say () {
120         say_color info "$*"
121 }
122
123 test "${test_description}" != "" ||
124 error "Test script did not set test_description."
125
126 if test "$help" = "t"
127 then
128         echo "$test_description"
129         exit 0
130 fi
131
132 exec 5>&1
133 if test "$verbose" = "t"
134 then
135         exec 4>&2 3>&1
136 else
137         exec 4>/dev/null 3>/dev/null
138 fi
139
140 test_failure=0
141 test_count=0
142 test_fixed=0
143 test_broken=0
144
145 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
146
147 test_tick () {
148         if test -z "${test_tick+set}"
149         then
150                 test_tick=1112911993
151         else
152                 test_tick=$(($test_tick + 60))
153         fi
154         GIT_COMMITTER_DATE="$test_tick -0700"
155         GIT_AUTHOR_DATE="$test_tick -0700"
156         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
157 }
158
159 # You are not expected to call test_ok_ and test_failure_ directly, use
160 # the text_expect_* functions instead.
161
162 test_ok_ () {
163         test_count=$(expr "$test_count" + 1)
164         say_color "" "  ok $test_count: $@"
165 }
166
167 test_failure_ () {
168         test_count=$(expr "$test_count" + 1)
169         test_failure=$(expr "$test_failure" + 1);
170         say_color error "FAIL $test_count: $1"
171         shift
172         echo "$@" | sed -e 's/^/        /'
173         test "$immediate" = "" || { trap - exit; exit 1; }
174 }
175
176 test_known_broken_ok_ () {
177         test_count=$(expr "$test_count" + 1)
178         test_fixed=$(($test_fixed+1))
179         say_color "" "  FIXED $test_count: $@"
180 }
181
182 test_known_broken_failure_ () {
183         test_count=$(expr "$test_count" + 1)
184         test_broken=$(($test_broken+1))
185         say_color skip "  still broken $test_count: $@"
186 }
187
188 test_debug () {
189         test "$debug" = "" || eval "$1"
190 }
191
192 test_run_ () {
193         eval >&3 2>&4 "$1"
194         eval_ret="$?"
195         return 0
196 }
197
198 test_skip () {
199         this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
200         this_test="$this_test.$(expr "$test_count" + 1)"
201         to_skip=
202         for skp in $GIT_SKIP_TESTS
203         do
204                 case "$this_test" in
205                 $skp)
206                         to_skip=t
207                 esac
208         done
209         case "$to_skip" in
210         t)
211                 say_color skip >&3 "skipping test: $@"
212                 test_count=$(expr "$test_count" + 1)
213                 say_color skip "skip $test_count: $1"
214                 : true
215                 ;;
216         *)
217                 false
218                 ;;
219         esac
220 }
221
222 test_expect_failure () {
223         test "$#" = 2 ||
224         error "bug in the test script: not 2 parameters to test-expect-failure"
225         if ! test_skip "$@"
226         then
227                 say >&3 "checking known breakage: $2"
228                 test_run_ "$2"
229                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
230                 then
231                         test_known_broken_ok_ "$1"
232                 else
233                     test_known_broken_failure_ "$1"
234                 fi
235         fi
236         echo >&3 ""
237 }
238
239 test_expect_success () {
240         test "$#" = 2 ||
241         error "bug in the test script: not 2 parameters to test-expect-success"
242         if ! test_skip "$@"
243         then
244                 say >&3 "expecting success: $2"
245                 test_run_ "$2"
246                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
247                 then
248                         test_ok_ "$1"
249                 else
250                         test_failure_ "$@"
251                 fi
252         fi
253         echo >&3 ""
254 }
255
256 test_expect_code () {
257         test "$#" = 3 ||
258         error "bug in the test script: not 3 parameters to test-expect-code"
259         if ! test_skip "$@"
260         then
261                 say >&3 "expecting exit code $1: $3"
262                 test_run_ "$3"
263                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
264                 then
265                         test_ok_ "$2"
266                 else
267                         test_failure_ "$@"
268                 fi
269         fi
270         echo >&3 ""
271 }
272
273 # This is not among top-level (test_expect_success | test_expect_failure)
274 # but is a prefix that can be used in the test script, like:
275 #
276 #       test_expect_success 'complain and die' '
277 #           do something &&
278 #           do something else &&
279 #           test_must_fail git checkout ../outerspace
280 #       '
281 #
282 # Writing this as "! git checkout ../outerspace" is wrong, because
283 # the failure could be due to a segv.  We want a controlled failure.
284
285 test_must_fail () {
286         "$@"
287         test $? -gt 0 -a $? -le 128
288 }
289
290 # Most tests can use the created repository, but some may need to create more.
291 # Usage: test_create_repo <directory>
292 test_create_repo () {
293         test "$#" = 1 ||
294         error "bug in the test script: not 1 parameter to test-create-repo"
295         owd=`pwd`
296         repo="$1"
297         mkdir "$repo"
298         cd "$repo" || error "Cannot setup test environment"
299         "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
300         error "cannot run git init -- have you built things yet?"
301         mv .git/hooks .git/hooks-disabled
302         cd "$owd"
303 }
304
305 test_done () {
306         trap - exit
307
308         if test "$test_fixed" != 0
309         then
310                 say_color pass "fixed $test_fixed known breakage(s)"
311         fi
312         if test "$test_broken" != 0
313         then
314                 say_color error "still have $test_broken known breakage(s)"
315                 msg="remaining $(($test_count-$test_broken)) test(s)"
316         else
317                 msg="$test_count test(s)"
318         fi
319         case "$test_failure" in
320         0)
321                 # We could:
322                 # cd .. && rm -fr trash
323                 # but that means we forbid any tests that use their own
324                 # subdirectory from calling test_done without coming back
325                 # to where they started from.
326                 # The Makefile provided will clean this test area so
327                 # we will leave things as they are.
328
329                 say_color pass "passed all $msg"
330                 exit 0 ;;
331
332         *)
333                 say_color error "failed $test_failure among $msg"
334                 exit 1 ;;
335
336         esac
337 }
338
339 # Test the binaries we have just built.  The tests are kept in
340 # t/ subdirectory and are run in trash subdirectory.
341 PATH=$(pwd)/..:$PATH
342 GIT_EXEC_PATH=$(pwd)/..
343 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
344 unset GIT_CONFIG
345 unset GIT_CONFIG_LOCAL
346 GIT_CONFIG_NOSYSTEM=1
347 GIT_CONFIG_NOGLOBAL=1
348 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
349
350 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
351 export GITPERLLIB
352 test -d ../templates/blt || {
353         error "You haven't built things yet, have you?"
354 }
355
356 if ! test -x ../test-chmtime; then
357         echo >&2 'You need to build test-chmtime:'
358         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
359         exit 1
360 fi
361
362 . ../GIT-BUILD-OPTIONS
363
364 # Test repository
365 test=trash
366 rm -fr "$test"
367 test_create_repo $test
368 cd "$test"
369
370 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
371 for skp in $GIT_SKIP_TESTS
372 do
373         to_skip=
374         for skp in $GIT_SKIP_TESTS
375         do
376                 case "$this_test" in
377                 $skp)
378                         to_skip=t
379                 esac
380         done
381         case "$to_skip" in
382         t)
383                 say_color skip >&3 "skipping test $this_test altogether"
384                 say_color skip "skip all tests in $this_test"
385                 test_done
386         esac
387 done